"use strict";
exports.__esModule = true;
var React = require("react");
var style = {
    //webkitTouchCallout: 'none', /* iOS Safari */
    //webkitUserSelect: 'none', /* Safari */
    //khtmlUserSelect: 'none', /* Konqueror HTML */
    //mozUserSelect: 'none', /* Old versions of Firefox */
    //msUserSelect: 'none', /* Internet Explorer/Edge */
    userSelect: 'none'
};
var tagSpecial = function (special_label, tag) {
    if (tag === "reference") {
        return "Refer\u00EAncia - " + special_label;
    }
    if (special_label === "" || special_label === undefined) {
        return tag;
    }
    else {
        return special_label;
    }
};
var Mark = function (props) {
    var buttonStyle = {
        backgroundColor: "white",
        border: "none",
        color: "#000000",
        padding: "5px 5px",
        margin: "3px",
        textAlignProperty: "center",
        textDecoration: "none",
        display: "inline-block",
        fontSize: '10px',
        borderRadius: '4px'
    };
    var bgColor = '#84d2ff';
    if (props.tag === 'reference') {
        bgColor = '#00000057';
    }
    else if (props.color) {
        bgColor = props.color;
    }
    var fore = 'black';
    if (props.color) {
        var rgb = [parseInt(props.color.substring(1, 3), 16), parseInt(props.color.substring(3, 5), 16), parseInt(props.color.substring(5, 7), 16)];
        var uicolors = [rgb[0] / 255, rgb[1] / 255, rgb[2] / 255];
        var c = uicolors.map(function (col) {
            if (col <= 0.03928) {
                return col / 12.92;
            }
            return Math.pow((col + 0.055) / 1.055, 2.4);
        });
        var L = (0.2126 * c[0]) + (0.7152 * c[1]) + (0.0722 * c[2]);
        fore = (L > 0.179) ? 'black' : 'white';
    }
    return (React.createElement("mark", { style: { backgroundColor: bgColor, padding: '0 4px', color: fore }, "data-start": props.start, "data-end": props.end, onClick: function () { return props.onClickChange({ start: props.start, end: props.end, tag: props.tag, special_label: props.special_label, all: props }); } },
        props.content,
        props.showTags && props.tag && (React.createElement("span", { style: { fontSize: '0.7em', fontWeight: 500, marginLeft: 6, userSelect: 'none' } }, tagSpecial(props.special_label, props.tag)))));
};
exports["default"] = Mark;
//# sourceMappingURL=Mark.js.map